/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import com.sun.grizzly.comet.CometContext;
import com.sun.grizzly.comet.CometEngine;
import com.sun.grizzly.comet.CometEvent;
import com.sun.grizzly.comet.CometHandler;
import java.io.*;

import java.util.logging.Logger;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author arungupta
 */
public class CometServlet extends HttpServlet {

    private boolean firstRequest = true;
    CometContext context = null;
    private String contextPath;
    private Logger logger = Logger.getLogger("ttt");
    private static char[][] resultMatrix = {
        {' ', ' ', ' '},
        {' ', ' ', ' '},
        {' ', ' ', ' '}
    };
    private static final String X = "X";
    private static final String O = "O";
    private static final String imagePrefix = "/ttt-java/images/";
    private static final String winnerGreeting = "<h1>We have a winner!!!</h1>";
    
    private static String currentSymbol = X;

    @Override
    public void init(ServletConfig config) throws ServletException {
        contextPath = config.getServletContext().getContextPath() + "/tictactoe";

        CometContext c = CometEngine.getEngine().register(contextPath);
        c.setExpirationDelay(1 * 60 * 1000);
    }

    private char playTheGame(HttpServletRequest request, PrintWriter writer, CometContext context) 
            throws NumberFormatException, IOException {
        String position = request.getParameter("position");

        int row = Integer.parseInt(Character.toString(position.charAt(1)));
        int col = Integer.parseInt(Character.toString(position.charAt(3)));
        resultMatrix[row - 1][col - 1] = currentSymbol.charAt(0);

        dumpResultMatrix();

        char winner = isAWinner();
        if (winner != ' ') {
//            String script = "<script type='text/javascript'>parent.frames[1].reportWinner('winner')</script>";
//            String script = "<script type='text/javascript'>alert('winner')</script>";
//            context.notify(script);
            writer.print(winner);
            writer.flush();
            initResultMatrix();
            return winner;
        }
        
        currentSymbol = currentSymbol.equals(X) ? O : X;
        return ' ';
    }

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        PrintWriter responseWriter = response.getWriter();
        TTTListenerHandler cometHandler = new TTTListenerHandler();
        cometHandler.attach(responseWriter);

        CometEngine.getEngine().register(contextPath).addCometHandler(cometHandler);
        //context.addCometHandler(cometHandler);
        return;
    }

    void initResultMatrix() {
        for (int r = 0; r < 3; r++) {
            for (int c = 0; c < 3; c++) {
                resultMatrix[r][c] = ' ';
            }
        }
    }

    void dumpResultMatrix() {
        for (int r = 0; r < 3; r++) {
            String message = "Row " + r + ": ";
            for (int c = 0; c < 3; c++) {
                message += "<" + resultMatrix[r][c] + ">";
            }
            System.out.println(message);
        }
    }

    char isAWinner() {

        // row major
        for (int rows = 0; rows < 3; rows++) {
            if (resultMatrix[rows][1] != ' ') {
                if (resultMatrix[rows][0] == resultMatrix[rows][1] &&
                        resultMatrix[rows][1] == resultMatrix[rows][2]) {
                    return resultMatrix[rows][1];
                }
            }
        }

        // column major
        for (int cols = 0; cols < 3; cols++) {
            if (resultMatrix[1][cols] != ' ') {
                if (resultMatrix[0][cols] == resultMatrix[1][cols] &&
                        resultMatrix[1][cols] == resultMatrix[2][cols]) {
                    return resultMatrix[1][cols];
                }
            }
        }

        // diagonal major
        if (resultMatrix[1][1] != ' ') {
            if ((resultMatrix[0][0] == resultMatrix[1][1] &&
                    resultMatrix[1][1] == resultMatrix[2][2]) ||
                    (resultMatrix[0][2] == resultMatrix[1][1] &&
                    resultMatrix[1][1] == resultMatrix[2][0])) {
                return resultMatrix[1][1];
            }
        }
        return ' ';
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/plain");
        response.setHeader("Cache-Control", "private");
        response.setHeader("Pragma", "no-cache");
        PrintWriter responseWriter = response.getWriter();
        
        if (firstRequest) {
            context = CometEngine.getEngine().register(contextPath);
            firstRequest = false;
        }
 
        String action = request.getParameter("action");
        logger.info("In doPost: " + action);
        if (action != null) {
            if (action.equals("start")) {
                doGet(request, response);
                return;
            }  else if (action.equals("currentSymbol")) {
                responseWriter.print(currentSymbol);
                return;
            }
        }
        
        String position = request.getParameter("position");
        String imageLoc = imagePrefix + currentSymbol + ".png";

        char winner = playTheGame(request, response.getWriter(), context);
        
        String script = "<script type='text/javascript'>parent.frames[1].updateBoard({position: '" + position +
                "', imageLoc: '" + imageLoc + "'" +
                ((winner != ' ') ? ", result: '" + 
                "<img src=\"" + imagePrefix + winner + ".png\"><font size=\"+10\">won!!</h1>'" : "") + "})</script>";
        context.notify(script);
        
//        script = "<script type='text/javascript'>parent.frames[1].updateMessage('Your turn now')</script>";
//        context.notify(script);
        
        if (winner == ' ')
            response.sendRedirect("index.jsp");
    }

    /** 
     * Returns a short description of the servlet.
     */
    @Override
    public String getServletInfo() {
        return "Comet Servlet used by Tic Tac Toe";
    }

    public class TTTListenerHandler implements CometHandler<PrintWriter> {

        private PrintWriter writer;

        public void attach(PrintWriter writer) {
            this.writer = writer;
        }

        public void onEvent(CometEvent event) throws IOException {
            if (event.getType() == CometEvent.NOTIFY) {
                String output = (String) event.attachment();
                logger.info("CometEvent.NOTIFY => {}" + output);

                writer.println(output);
                writer.flush();
                event.getCometContext().resumeCometHandler(this);
            }
        }

        public void onInitialize(CometEvent event) throws IOException {
        }

        public void onInterrupt(CometEvent event) throws IOException {
            writer.flush();

            removeThisFromContext();
        }

        public void onTerminate(CometEvent event) throws IOException {
            removeThisFromContext();
        }

        private void removeThisFromContext() {
            writer.close();

            CometContext context = CometEngine.getEngine().getCometContext(contextPath);
            context.removeCometHandler(this);
        }
    }
    }
